from scoremanage import *
import pygame
import sys
from math import cos
from math import sin
from math import pi
from random import randrange
import pygame.locals as GAME_GLOBALS
import pygame.event as GAME_EVENTS

gs=Scoremanage("coelho_2-0_sco")
score=0
pseudo=""

lapin=pygame.image.load("Rabbit-b.svg")
lapin=pygame.transform.scale(lapin,(50,50))
g=9.81 #gravité terrestre en m/s²
deltaT=0.04 #à intervalle de deltaT secondes
ppm=250/5 #pixels par mètre
aL=vL=d=0
xL=yL=0.0

def x(t,v0,alpha):
    return (v0*cos(alpha)*t)
def y(t,v0,alpha):
    global g
    return (v0*sin(alpha)*t-0.5*g*t**2)

pygame.init()
pygame.font.init()
EcranLargeur=1000
EcranHauteur=562
ecran=pygame.display.set_mode((EcranLargeur,EcranHauteur))
pygame.display.set_caption("Jeu du lapin Coelho v.0b")

def quitter():
    pygame.quit()
    sys.exit()

polices=pygame.font.get_fonts()
police="couriernew"
if police in polices:
    police=police
elif "consolas" in polices:
    police="consolas"
else:
    police="liberationmono"
police=pygame.font.match_font(police,bold=True)

def ecrandefond():
    global EcranHauteur,EcranLargeur,ecran
    global murh,murb,dinosaure,xL,yL,lapin
    ecran.fill("light blue")
    pygame.draw.rect(ecran,"green",(0,450,EcranLargeur,EcranHauteur-450)) #Plaine
    murb=pygame.draw.rect(ecran,"orange",(400,530-150,25,150)) #Mur bas
    murh=pygame.draw.rect(ecran,"orange",(400,0,25,100)) #Mur haut
    oeuf=pygame.image.load("egg-a.svg")
    oeuf=pygame.transform.scale(oeuf,(75,100))
    ecran.blit(oeuf,(600,530-100))
    dinosaure=pygame.image.load("Dinosaur4-d.svg")
    dinosaure=pygame.transform.scale(dinosaure,(100,150))
    ecran.blit(dinosaure,(800,530-150))
    ecran.blit(lapin,(xL,yL))

def affichedonnees():
    global restlapins,score,police
    textlapins="Lapins : "+str(restlapins)
    font=pygame.font.Font(police,24)
    tl=font.render(textlapins,True,"magenta")
    ecran.blit(tl,(1000-175,5))
    textscore="Score : "+str(score)
    ts=font.render(textscore,True,"magenta")
    ecran.blit(ts,(5,5))

def affsc():
    ecrandefond()
    affichedonnees()
    scores=gs.lirsco()
    for i in range(0,10):
        texte=str(i)+" "+scores[(i*2)+1]+" "+str(scores[(i*2)])
        font=pygame.font.Font(police,24)
        ts=font.render(texte,True,"magenta")
        ecran.blit(ts,(200,80+(i*30)))
    comm="R : Recommencer     Esc : Quitter"
    font=pygame.font.Font(police,24)
    tc=font.render(comm,True,"magenta")
    ecran.blit(tc,(200,530))
    pygame.display.update()    
    while True:
        for event in GAME_EVENTS.get():
            if event.type==pygame.KEYDOWN:
                if event.key==pygame.K_r:
                    accueil()
                if event.key==pygame.K_ESCAPE:
                    quitter()
            if event.type==GAME_GLOBALS.QUIT:
                quitter()

def dempseudo():
    global score,xL,yL,pseudo
    xL,yL=100,530-50
    gs.score=score
    while True:    
        ecrandefond()
        affichedonnees()
        txt="Entrez votre pseudo :"
        font=pygame.font.Font(police,28)
        txts=font.render(txt,True,"magenta")
        ecran.blit(txts,(500-(18*21/2),150))
        for event in GAME_EVENTS.get():
            
                if event.type==pygame.KEYDOWN:
                    if event.key==pygame.K_RETURN:
                        gs.gamer=pseudo
                        gs.addsco()
                        affsc()
                    if event.key==pygame.K_ESCAPE:
                        quitter()
                    lettre=pygame.key.name(event.key)
                    if event.key==pygame.K_BACKSPACE:
                        if len(pseudo)>0:
                            pseudo=pseudo[:-1]
                    else:
                        if len(pseudo)<15:
                            if event.key==pygame.K_SPACE:
                                lettre=" "
                            if len(lettre)==1:
                                pseudo+=lettre
                if event.type==GAME_GLOBALS.QUIT:
                    quitter()
        #font=pygame.font.Font(police,28)
        tp=font.render(pseudo,True,"magenta")
        ecran.blit(tp,(550-(18*21/2),250))
        pygame.display.update()

def lance():
    global lapin,xL,yL
    global deltaT,ppm,aL,vL,restlapins,d,score
    temps=0.0
    touche=False
    while not touche:
        xL=(x(temps,vL,aL*2*pi/360))
        yL=(y(temps,vL,aL*2*pi/360))
        xL=d+xL*ppm
        yL=530-50-yL*ppm
        ecrandefond()
        affichedonnees()
        pygame.display.update()
        if xL>400-50 and xL<425 and (yL>=530-150-40 or yL<=100):
            touche=True
            restlapins=restlapins-1
            ecrandefond()
            affichedonnees()
            pygame.display.update()
        if xL>=600-50 and xL<=675 and yL>530-100-25:
            touche=True
            score=score+500
            ecrandefond()
            affichedonnees()
            pygame.display.update()
        if xL>800-50 and yL>530-50:
            touche=True
            restlapins=restlapins-1
            ecrandefond()
            affichedonnees()
            pygame.display.update()
        if temps>deltaT and yL>=530-50:
            if touche==False and xL>400:
                score+=100
            touche=True
            ecrandefond()
            affichedonnees()
            pygame.display.update()
        pygame.time.wait(int(1000*deltaT))
        temps=temps+deltaT
    pygame.time.wait(4000)
    return(restlapins)

def initialiselapin():
    global aL,vL,d
    global lapin,xL,yL
    aL=45
    vL=7
    lancement=False
    d=randrange(1,301)
    xL=d
    yL=530-50

    while not lancement:
        ecrandefond()
        affichedonnees()
        pygame.draw.line(ecran,"red",(d,530),(d+(vL*cos(aL*2*pi/360)*15),530-(vL*sin(aL*2*pi/360)*15)),2)
        pygame.display.update()

        for event in GAME_EVENTS.get():

            if event.type==pygame.KEYDOWN:

                if event.key==pygame.K_RIGHT:
                    aL=aL-1
                    if aL<30:
                        aL=30
                if event.key==pygame.K_LEFT:
                    aL=aL+1
                    if aL>80:
                        aL=80
                if event.key==pygame.K_UP:
                    vL=vL+1
                    if vL>15:
                        vL=15
                if event.key==pygame.K_DOWN:
                    vL=vL-1
                    if vL<1:
                        vL=1
                if event.key==pygame.K_ESCAPE:
                    quitter()
                if event.key==pygame.K_RETURN:
                    lancement=True
                    #lance()
            if event.type==GAME_GLOBALS.QUIT:
                quitter()

okay=True
restlapins=3

def noyauxjeu():
    global restlapins,okay,pseudo,score
    pseudo=""
    score=0
    okay=True
    restlapins=3
    while okay:
        initialiselapin()
        restlapins=lance()
        if restlapins<1:
            okay=False
    dempseudo()

def accueil():
    global xL,yL
    xL,yL=100,530-50
    ecrandefond()
    butjeu=pygame.image.load("butjeu.png")
    butjeu=pygame.transform.scale(butjeu,(1000,562))
    ecran.blit(butjeu,(0,0))
    pygame.display.update()
    while True:
        for event in GAME_EVENTS.get():
            if event.type==pygame.KEYDOWN:
                if event.key==pygame.K_j:
                    noyauxjeu()
                if event.key==pygame.K_ESCAPE:
                    quitter()
            if event.type==GAME_GLOBALS.QUIT:
                quitter()

accueil()
